/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PLevelBreakUpProc
 *  fire.pb.event.Event
 *  fire.pb.event.LevelBreakEvent
 *  fire.pb.event.LevelContinueEvent
 *  fire.pb.event.LevelupEvent
 *  fire.pb.npc.SVisitNpc
 *  fire.pb.team.TeamManager
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.AcceptedScenarioMission
 *  xbean.CommitedScenarioMission
 *  xbean.Mission
 *  xbean.Pod
 *  xtable.Acceptedscenariomission
 *  xtable.Commitedscenariomission
 *  xtable.Properties
 *  xtable.Showingmission
 */
package fire.pb.mission;

import fire.pb.PLevelBreakUpProc;
import fire.pb.event.Event;
import fire.pb.event.LevelBreakEvent;
import fire.pb.event.LevelContinueEvent;
import fire.pb.event.LevelupEvent;
import fire.pb.mission.IRoleMissionColumn;
import fire.pb.mission.MissionBranchScenario;
import fire.pb.mission.MissionConfig;
import fire.pb.mission.MissionMajorScenario;
import fire.pb.mission.MissionManager;
import fire.pb.mission.Module;
import fire.pb.mission.PAcceptMajorMission;
import fire.pb.mission.RoleMission;
import fire.pb.mission.SReqMissionCanAccept;
import fire.pb.mission.UtilHelper;
import fire.pb.npc.SVisitNpc;
import fire.pb.team.TeamManager;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.AcceptedScenarioMission;
import xbean.CommitedScenarioMission;
import xbean.Mission;
import xbean.Pod;
import xtable.Acceptedscenariomission;
import xtable.Commitedscenariomission;
import xtable.Properties;
import xtable.Showingmission;

public class MissionColumn
implements IRoleMissionColumn<RoleMission> {
    private final long roleid;
    private final MissionMajorScenario majorscenario;
    private final AcceptedScenarioMission branchdata;

    public MissionColumn(long roleid, boolean readonly) {
        this.roleid = roleid;
        this.majorscenario = new MissionMajorScenario(roleid, readonly);
        if (readonly) {
            AcceptedScenarioMission xxx = Acceptedscenariomission.select((Long)roleid);
            this.branchdata = xxx == null ? Pod.newAcceptedScenarioMissionData() : xxx;
        } else {
            AcceptedScenarioMission xxx = Acceptedscenariomission.get((Long)roleid);
            if (xxx == null) {
                this.branchdata = Pod.newAcceptedScenarioMission();
                Acceptedscenariomission.insert((Long)roleid, (AcceptedScenarioMission)this.branchdata);
            } else {
                this.branchdata = xxx;
            }
        }
    }

    final void afterEnterWorld() {
        Integer nextmission;
        if (this.majorscenario.getState() == 1 && !this.majorscenario.getConf().rewardInfo.postMissionList.isEmpty() && (nextmission = this.majorscenario.getConf().rewardInfo.postMissionList.get(0)) != null) {
            new PAcceptMajorMission(this.roleid, nextmission, true).call();
        }
        Showingmission.remove((Long)this.roleid);
        if (this.majorscenario.getState() == -1) {
            Integer missionline;
            int taskid;
            int school = Properties.selectSchool((Long)this.roleid);
            Set<Integer> all = MissionManager.getInstance().getTasklineCanAccept(school);
            Iterator<Integer> iterator = all.iterator();
            while (!(!iterator.hasNext() || UtilHelper.isMajorScenarioMission(taskid = UtilHelper.getMissionId(missionline = iterator.next(), UtilHelper.getFirstStep())) && new PAcceptMajorMission(this.roleid, taskid, true).call())) {
            }
        } else {
            this.refreshPostMissionLine(0);
        }
    }

    protected void getCanacceptQuest(List<Integer> quests) {
        for (Mission mission : this.branchdata.getAccepted().values()) {
            if (mission.getStatus() != -1 || UtilHelper.isTuPoMission(mission.getId())) continue;
            quests.add(mission.getId());
        }
    }

    @Override
    public long getRoleId() {
        return this.roleid;
    }

    public RoleMission getMission(int missionid) {
        if (UtilHelper.isBranchScenarioMission(missionid)) {
            int lineid = UtilHelper.getMissionLineid(missionid);
            Mission mission = (Mission)this.branchdata.getAccepted().get(lineid);
            if (mission == null || mission.getId() != missionid) {
                return null;
            }
            return new MissionBranchScenario(this.roleid, mission);
        }
        if (UtilHelper.isMajorScenarioMission(missionid)) {
            if (missionid == this.majorscenario.getId()) {
                return this.majorscenario;
            }
            return null;
        }
        return null;
    }

    public boolean hasTuPoMission() {
        for (RoleMission task : this) {
            if (task.getConf() == null || task.getId() / 10000 != 51) continue;
            return true;
        }
        return false;
    }

    public RoleMission getMissionByLineid(int tasklineid) {
        int id = UtilHelper.getMissionId(tasklineid, UtilHelper.getFirstStep());
        if (UtilHelper.isBranchScenarioMission(id)) {
            Mission xtask = (Mission)this.branchdata.getAccepted().get(tasklineid);
            if (xtask == null) {
                return null;
            }
            return new MissionBranchScenario(this.roleid, xtask);
        }
        if (UtilHelper.isMajorScenarioMission(id)) {
            return this.majorscenario;
        }
        return null;
    }

    public ArrayList<Integer> getMissionsByNpcid(int npcid, SVisitNpc svisitNpc) {
        ArrayList<Integer> missions = new ArrayList<Integer>();
        for (RoleMission mission : this) {
            int missionid = mission.getId();
            if (mission.getConf() == null || mission.getConf().exeIndo.npcID != npcid) continue;
            if (mission.getState() != -1) {
                missions.add(missionid);
                if (mission.getConf().exeIndo.unionSeekHelp > 0) {
                    svisitNpc.services.add(mission.getConf().exeIndo.unionSeekHelp);
                }
                if (mission.getConf().exeIndo.worldSeekHelp > 0) {
                    svisitNpc.services.add(mission.getConf().exeIndo.worldSeekHelp);
                }
                if (mission.getConf().aiInfo.aIID <= 0 || mission.getConf().battleInfo.battleVideo <= 0) continue;
                svisitNpc.services.add(mission.getConf().battleInfo.battleVideo);
                continue;
            }
            if (!UtilHelper.isFirstStepInLine(UtilHelper.getMissionStep(missionid))) continue;
            missions.add(missionid);
            if (mission.getConf().exeIndo.unionSeekHelp > 0) {
                svisitNpc.services.add(mission.getConf().exeIndo.unionSeekHelp);
            }
            if (mission.getConf().exeIndo.worldSeekHelp > 0) {
                svisitNpc.services.add(mission.getConf().exeIndo.worldSeekHelp);
            }
            if (mission.getConf().aiInfo.aIID <= 0 || mission.getConf().battleInfo.battleVideo <= 0) continue;
            svisitNpc.services.add(mission.getConf().battleInfo.battleVideo);
        }
        return missions;
    }

    public int getMissionState(int taskid) {
        int lineid = UtilHelper.getMissionLineid(taskid);
        CommitedScenarioMission cst = Commitedscenariomission.select((Long)this.roleid);
        if (cst != null && cst.getCommitted().contains(lineid)) {
            return 1;
        }
        if (UtilHelper.isBranchScenarioMission(taskid)) {
            Mission xtask = (Mission)this.branchdata.getAccepted().get(lineid);
            if (xtask == null) {
                return -1;
            }
            if (xtask.getId() == taskid) {
                return xtask.getStatus();
            }
            if (!xtask.getPath().contains(taskid)) {
                return -1;
            }
            return 1;
        }
        if (UtilHelper.isMajorScenarioMission(taskid)) {
            if (taskid == this.majorscenario.getId()) {
                return this.majorscenario.getState();
            }
            if (this.majorscenario.data.getPath().contains(taskid)) {
                return 1;
            }
            return -1;
        }
        return -1;
    }

    @Override
    public Iterator<RoleMission> iterator() {
        return new MissionIterator();
    }

    void onEvent(Event e) {
        if (e instanceof LevelupEvent) {
            this.onLevelChange();
        } else if (e instanceof LevelBreakEvent) {
            final LevelBreakEvent ev = (LevelBreakEvent)e;
            new Procedure(){

                protected boolean process() {
                    SReqMissionCanAccept send = new SReqMissionCanAccept();
                    Module.getInstance().getCanAcceptMission4TuPo(MissionColumn.this.roleid, send.missions, ev.getRolelevel());
                    Procedure.psend((long)MissionColumn.this.roleid, (Protocol)send);
                    return true;
                }
            }.call();
        } else if (e instanceof LevelContinueEvent) {
            new PLevelBreakUpProc(this.roleid).call();
        }
        this.majorscenario.onEvent(e);
        ArrayList<Integer> branchtasks = new ArrayList<Integer>();
        for (Mission xtask : this.branchdata.getAccepted().values()) {
            if (UtilHelper.isTuPoMission(xtask.getId())) continue;
            branchtasks.add(xtask.getId());
        }
        Iterator<Object> iterator = branchtasks.iterator();
        while (iterator.hasNext()) {
            int taskid = (Integer)iterator.next();
            RoleMission mission = this.getMission(taskid);
            if (mission == null) continue;
            mission.onEvent(e);
        }
    }

    private final void onLevelChange() {
        this.refreshPostMissionLine(0);
    }

    final boolean refreshPostMissionLine() {
        return this.refreshPostMissionLine(0);
    }

    final boolean refreshPostMissionLine(int completedtaskline) {
        Set<Integer> posts = MissionManager.getInstance().getPostmissions(completedtaskline);
        boolean ret = true;
        if (posts != null) {
            for (final Integer mission : posts) {
                if (UtilHelper.isBranchScenarioMission(mission)) {
                    if (UtilHelper.isTuPoMission(mission)) continue;
                    int tasklineid = UtilHelper.getMissionLineid(mission);
                    Mission xtask = (Mission)this.branchdata.getAccepted().get(tasklineid);
                    if (xtask != null && xtask.getStatus() != -1) continue;
                    if (PAcceptMajorMission.canAccept(this.roleid, mission)) {
                        MissionConfig conf = MissionManager.getInstance().getMissionConfig(mission);
                        if (conf == null) continue;
                        if (conf.exeIndo.npcID > 0) {
                            if (UtilHelper.isTuPoMission(mission)) continue;
                            xtask = Pod.newMission();
                            xtask.setId(mission.intValue());
                            xtask.setStatus(-1);
                            this.branchdata.getAccepted().put(tasklineid, xtask);
                            continue;
                        }
                        Procedure.pexecuteWhileCommit((Procedure)new Procedure(){

                            protected boolean process() {
                                TeamManager.getTeamByRoleId((long)MissionColumn.this.roleid);
                                new PAcceptMajorMission(MissionColumn.this.roleid, mission, true).call();
                                return true;
                            }
                        });
                        continue;
                    }
                    this.branchdata.getAccepted().remove(tasklineid);
                    continue;
                }
                if (!UtilHelper.isMajorScenarioMission(mission) || !PAcceptMajorMission.canAccept(this.roleid, mission)) continue;
                ret = new PAcceptMajorMission(this.roleid, mission, true).call();
            }
        }
        new Procedure(){

            protected boolean process() {
                SReqMissionCanAccept send = new SReqMissionCanAccept();
                Module.getInstance().getCanAcceptMission(MissionColumn.this.roleid, send.missions);
                Procedure.psend((long)MissionColumn.this.roleid, (Protocol)send);
                return true;
            }
        }.call();
        return ret;
    }

    public boolean removeMissionline(int taskline) {
        this.branchdata.getAccepted().remove(taskline);
        return true;
    }

    private final class MissionIterator
    implements Iterator<RoleMission> {
        private final Iterator<Integer> iter;
        private boolean majorMissionshowed;

        private MissionIterator() {
            this.iter = MissionColumn.this.branchdata.getAccepted().keySet().iterator();
            this.majorMissionshowed = MissionColumn.this.majorscenario.getId() == 0;
        }

        @Override
        public boolean hasNext() {
            return this.iter.hasNext() || !this.majorMissionshowed;
        }

        @Override
        public RoleMission next() {
            if (this.iter.hasNext()) {
                Mission data = (Mission)MissionColumn.this.branchdata.getAccepted().get(this.iter.next());
                return new MissionBranchScenario(MissionColumn.this.roleid, data);
            }
            this.majorMissionshowed = true;
            return MissionColumn.this.majorscenario;
        }

        @Override
        public void remove() {
            this.iter.remove();
        }
    }
}

